<script lang="ts">
  import { onMount } from 'svelte';
  let heroTitle: HTMLElement;
  let heroTitleSub: HTMLElement;
  let heroTitleSubGradient: HTMLElement;
  let heroUnderscore: HTMLElement;
  let question: HTMLElement;
  let arrows: HTMLElement[] = new Array(2);
  let cross: HTMLElement;
  let stripes: SVGPathElement[] = new Array(8);

  let blinkCount = 2;
  let blinkDelay = 150;
  let textDelay = 50;
  let shortTextDelay = 20;

  onMount (() => {
    let heroTitleText = "SOFTWARE";
    let heroTitleSubText = "is my ";
    let heroTitleSubGradientText = "passion.";
    let questionText = "Otherwise you wouldn't be here, would you?";

    for (let i = 0; i < blinkCount * 2; i++) {
      if(i%2 === 0) {
        setTimeout(() => {
          for (let arrow of arrows) {
            arrow.style.visibility = "hidden";
          }
        }, blinkDelay * i);
      } else {
        setTimeout(() => {
          for (let arrow of arrows) {
            arrow.style.visibility = "visible";
          }
        }, blinkDelay * i);
      }
    }

    let titleDelay = blinkDelay * blinkCount * 2;
    setTimeout(() => {
      for (let i = 0; i < heroTitleText.length; i++) {
        setTimeout(() => {heroTitle.innerText += heroTitleText[i]}, textDelay * i);
      }
    }, titleDelay);

    let titleSubDelay = titleDelay + heroTitleText.length * textDelay;
    setTimeout(() => {
      blinkUnderscore();
      for (let i = 0; i < heroTitleSubText.length; i++) {
        setTimeout(() => {heroTitleSub.innerText += heroTitleSubText[i]}, textDelay * i);
      }
    }, titleSubDelay);

    let titleSubGradientDelay = titleSubDelay + heroTitleSubText.length * textDelay;
    setTimeout(() => {
      for (let i = 0; i < heroTitleSubGradientText.length; i++) {
        setTimeout(() => {heroTitleSubGradient.innerText += heroTitleSubGradientText[i]}, textDelay * i);
      }
    }, titleSubGradientDelay);

    let questionDelay = titleSubGradientDelay + heroTitleSubGradientText.length * textDelay;
    setTimeout(() => {
      for (let i = 0; i < questionText.length; i++) {
        setTimeout(() => {question.innerText += questionText[i]}, shortTextDelay * i);
      }
    }, questionDelay);

    setTimeout(() => {
      cross.style.visibility = "visible";
      setTimeout(() => {cross.style.visibility = "hidden";}, 200);
      setTimeout(() => {cross.style.visibility = "visible";}, 400);
      setTimeout(() => {cross.style.visibility = "hidden";}, 600);
      setTimeout(() => {cross.style.visibility = "visible";}, 800);

      for (let i = 0; i < stripes.length; i++) {
        setTimeout(() => {stripes[i].style.visibility = "visible"}, 100 + 75 * i);
      }
    }, questionDelay + questionText.length * shortTextDelay);
  });

  function blinkUnderscore() {
    if(heroUnderscore.style.visibility == "visible") {
      heroUnderscore.style.visibility = "hidden";
    } else {
      heroUnderscore.style.visibility = "visible";
    }
    setTimeout(blinkUnderscore, 500);
  }
</script>

<img id="logo" src="/ligature.svg" alt="" />

<div id="heroContainer">
  <img bind:this={arrows[0]} class="heroArrow" src="/arrow.svg" alt="" style="top: 0;" />
  <div id="heroText">
    <div bind:this={heroTitle}></div>
    <div bind:this={heroUnderscore} style="visibility: hidden;">_</div>
  </div>
  <div id="heroTextSub">
    <div bind:this={heroTitleSub}></div>
    <div bind:this={heroTitleSubGradient} style="background-image: linear-gradient(115deg, #f7f7ff, #cbcbdb); background-clip: text; -webkit-text-fill-color: transparent;"></div>
  </div>
  <img bind:this={arrows[1]} class="heroArrow" src="/arrow.svg" alt="" style="right: 0; bottom: 0; transform: rotate(180deg)"/>
</div>
<div bind:this={question} id="question"></div>
<img bind:this={cross} id="cross" src="/cross.svg" alt="" />
<div id="stripes">
  <svg width="calc(40vw + 3rem)" viewBox="0 0 100 25" xmlns="http://www.w3.org/2000/svg">
    <path bind:this={stripes[8]} style="fill:#f7f7ff;fill-opacity:1;stroke-width:.265" d="m95.41494-30.23033.00012 22.10656 7.10481-2.58594z" transform="rotate(20)"/>
    <path bind:this={stripes[7]} style="fill:#f7f7ff;fill-opacity:1;stroke-width:.265" d="m83.41485-30.36052.00007 26.60444 8.00025-2.91185-.00007-26.60444z" transform="rotate(20)"/>
    <path bind:this={stripes[6]} style="fill:#f7f7ff;fill-opacity:1;stroke-width:.265" d="M71.4152-25.993 71.41477.61162l8.00026-2.91186-.00008-26.60444z" transform="rotate(20)"/>
    <path bind:this={stripes[5]} style="fill:#f7f7ff;fill-opacity:1;stroke-width:.265" d="M59.41506-21.62531 59.41464 4.9793l8.00026-2.91186-.00008-26.60444z" transform="rotate(20)"/>
    <path bind:this={stripes[4]} style="fill:#f7f7ff;fill-opacity:1;stroke-width:.265" d="m47.41492-17.25762.00007 26.60444 7.99977-2.91167.00041-26.60462z" transform="rotate(20)"/>
    <path bind:this={stripes[3]} style="fill:#f7f7ff;fill-opacity:1;stroke-width:.265" d="m35.41478-12.88993.00007 26.60445 8.00026-2.91186-.00008-26.60444z" transform="rotate(20)"/>
    <path bind:this={stripes[2]} style="fill:#f7f7ff;fill-opacity:1;stroke-width:.265" d="m23.41513-8.52241-.00041 26.60462 8.00025-2.91185-.00007-26.60445z" transform="rotate(20)"/>
    <path bind:this={stripes[1]} style="fill:#f7f7ff;fill-opacity:1;stroke-width:.265" d="m11.41499-4.15472.00007 26.60445 7.99977-2.91168.00041-26.60462z" transform="rotate(20)"/>
    <path bind:this={stripes[0]} style="fill:#f7f7ff;fill-opacity:1;stroke-width:.265" d="m0 0 7.41511 20.37285V-2.69888z" transform="rotate(20)"/>
  </svg>
</div>

<style>
:root{
  --hero-size: calc(7vw + 1rem);
  --hero-smaller: calc(var(--hero-size) * 0.6);
  --question-left: calc(7vw + var(--hero-size) * 0.6 * 1.2);
  --question-top: calc(16vh + var(--hero-size) + var(--hero-smaller) + var(--hero-smaller) * 0.3 + 15vh);
}
#logo {
  position: absolute;
  left: 2vh;
  top: 2vh;
  height: calc(3vh + 1rem);
}
#heroContainer {
  display: flex;
  flex-direction: column;
  position: absolute;
  left: 7vw;
  top: 16vh;
  font-size: var(--hero-size);
}
#heroText {
  display: flex;
  flex-direction: row;
  font-family: Desolator-Framework;
  margin-left: 0.5em;
  margin-right: 0.5em;
  line-height: 1.5;
}
#heroTextSub {
  display: flex;
  flex-direction: row;
  font-family: Desolator;
  font-size: var(--hero-smaller);
  margin-left: 1.2em;
  margin-right: 1em;
  margin-top: -0.3em;
  margin-bottom: 0.3em;
}
#question {
  position: absolute;
  left: var(--question-left);
  top: var(--question-top);
  margin-left: -0.1em;
  font-family: Raleway;
  font-size: calc(1.8vw + 1rem);
  font-weight: 500;
  letter-spacing: -1px;
}
.heroArrow{
  position: absolute;
  width: 0.75em;
}
#cross {
  position: absolute;
  left: calc(var(--question-left) + 35vw + 20rem);
  top: calc(var(--question-top) + 3rem);
  width: calc(2vw + 1rem);
  visibility: hidden;
}
#stripes {
  position: absolute;
  left: var(--question-left);
  top: calc(var(--question-top) + 8vh + 2rem);
  visibility: hidden;
}
@media (max-width: 1200px) {
  :root {
    --hero-size: calc(5vw + 1rem);
  }

  #question {
    font-size: calc(1.3vw + 1rem);
  }

  #cross {
    left: calc(var(--question-left) + 25vw + 20rem);
    top: calc(var(--question-top) + 2.5rem);
    width: calc(1vw + 1rem);
  }
  #stripes > svg {
    width: calc(30vw + 3rem);
  }
}
</style>
